//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  TBitmap / TPngImage / TGigImage ̉摜 TIcon ̉摜쐬
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2022N1103 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 10 rh 19043 Pro 64 bit + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.StdCtrls,
  Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    Image2: TImage;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    FInitDir     : string;
    FImgFilePath : string;
  public
    { Public 錾 }
  end;

  procedure BitmapToAlphaBitmap(TargetBitmap: TBitmap; TransColor: TColor);

var
  Form1: TForm1;

implementation

uses
  Vcl.Imaging.GIFImg,
  Vcl.Imaging.pngimage;

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  FInitDir := ExpandFileName('..\Images\');
end;

//=============================================================================
//  TBitmap摜ACR摜쐬
//  TBitmap ̉摜 TIcon ̉摜쐬
//
//  TIconInfoR[h^̓}EXJ[\쐬ɂgp
//  TIconInfo.fIcon T rue ̎̓ACR쐬DFalse ̎̓}EXJ[\쐬
//  TIconInfo.xHotspo,TIconInfo.yHotspot ̓}EX̃zbgX|bgݒp
//  ACR쐬ł͎gpȂ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LSavePath   : string;
  LFileExt    : string;
  LBitmap     : TBitmap;
  LPngImage   : TPngImage;
  LGifImage   : TGIFImage;
  LTransColor : TColor;
  LIcon       : TIcon;
  LIconInfo   : TIconInfo;
  LBackBitmap : TBitmap;
begin
  OpenPictureDialog1.Filter     := '摜t@C|*.bmp;*.png;*.gif';
  OpenPictureDialog1.InitialDir := FInitDir;
  if not OpenPictureDialog1.Execute then exit;

  FImgFilePath := OpenPictureDialog1.FileName;
  FInitDir     :=  ExtractFileDir(FImgFilePath);
  LFileExt     := LowerCase(ExtractFileExt(FImgFilePath));

  Image1.Picture.Assign(nil);
  Image2.Picture.Assign(nil);


  LBitmap     := TBitmap.Create;
  LPngImage  := TPngImage.Create;
  LGifImage  := TGIFImage.Create;

  try
    // TBitmap ̉摜̏ꍇ
    if LFileExt = '.bmp' then begin
      LBitmap.LoadFromFile(FImgFilePath);
      Image1.Canvas.Draw(0, 0, LBitmap);

      LTransColor := LBitmap.Canvas.Pixels[0, LBitmap.Height - 1];
      BitmapToAlphaBitmap(LBitmap, LTransColor);
    end;


    // TPngImage ̉摜̏ꍇ
    if LFileExt = '.png' then begin
      LPngImage.LoadFromFile(FImgFilePath);
      Image1.Canvas.Draw(0, 0, LPngImage);

      // At@`l TPngImage 摜肵Ă̂œɏ͕sv
      LBitmap.Assign(LPngImage);
    end;


    // TGifImage ̉摜̏ꍇ
    if LFileExt = '.gif' then begin
      LGifImage.LoadFromFile(FImgFilePath);
      Image1.Canvas.Draw(0, 0, LGifImage);

      LTransColor := LGifImage.Bitmap.TransparentColor;
      LBitmap.Assign(LGifImage);
      BitmapToAlphaBitmap(LBitmap, LTransColor);
    end;


    LIcon := TIcon.Create;
    try
      // TIconInfo R[h^̒lZbg
      LIconInfo.fIcon    := True;
      LIconInfo.hbmMask  := LBitmap.Handle;
      LIconInfo.hbmColor := LBitmap.Handle;
      // TBitmap 摜 TIcon 摜쐬
      LIcon.Handle := CreateIconIndirect(LIconInfo );

      LSavePath  := '..\Images\Simple_32bit.ico';
      LIcon.SaveToFile(LSavePath);
      Label1.Caption := ExtractFileName(FImgFilePath);

      LBackBitmap := TBitmap.Create;
      try
        // ߏԂ̊mFpɁCwis͗l̉摜ɂɂ
        LBackBitmap.LoadFromFile(ExpandFileName('..\Images\backTexture_01.bmp'));
        Image2.Canvas.Brush.Bitmap := LBackBitmap;
        Image2.Canvas.FillRect(Image2.ClientRect);
      finally
        FreeAndNil(LBackBitmap);
      end;

      // 쐬 TIcon 摜 TImage ɕ`
      Image2.Canvas.Draw(0, 0, LIcon);
    finally
      FreeAndNil(LIcon);
    end;
  finally
    FreeAndNil(LBitmap);
    FreeAndNil(LPngImage);
    FreeAndNil(LGifImage);
  end;
end;

//-----------------------------------------------------------------------------
//   TBitmap 摜At@`lt TBitmap 摜ɂ
//   TransColor ̐F̃sNZ𓧖F̃sNZɂ
//  F ARGB ̒lS 0 ̃sNZ
//-----------------------------------------------------------------------------
procedure BitmapToAlphaBitmap(TargetBitmap: TBitmap; TransColor: TColor);
type
  TRGBQArray = array [0..4095] of RGBQUAD;
  PRGBQArray = ^TRGBQArray;
var
  LIsSemTrans : Boolean;
  LSrcBitmap  : TBitmap;
  LXPos       : integer;
  LYPos       : Integer;
  LSrcBmpScan : PRGBQArray;
  LDstBmpScan : PRGBQArray;
  LRValue     : Byte;
  LGValue     : Byte;
  LBValue     : Byte;
  LDstAValue : Byte;
  LDstRValue : Byte;
  LDstGValue : Byte;
  LDstBValue : Byte;
begin
  LSrcBitmap := TBitmap.Create;
  try
    TargetBitmap.Canvas.Lock;
    LSrcBitmap.Canvas.Lock;

    LIsSemTrans := False;

    TargetBitmap.AlphaFormat := afIgnored;
    TargetBitmap.PixelFormat := pf32bit;
    LSrcBitmap.Assign(TargetBitmap);

    LRValue := GetRValue(TransColor);
    LGValue := GetGValue(TransColor);
    LBValue := GetBValue(TransColor);

    for LYPos := 0 to TargetBitmap.Height - 1 do begin
      LSrcBmpScan := LSrcBitmap.ScanLine[LYPos];
      LDstBmpScan := TargetBitmap.ScanLine[LYPos];

      for LXPos := 0 to TargetBitmap.Width - 1 do begin

        LDstAValue := LSrcBmpScan[LXPos].rgbReserved;
        LDstRValue := LSrcBmpScan[LXPos].rgbRed;
        LDstGValue := LSrcBmpScan[LXPos].rgbGreen;
        LDstBValue := LSrcBmpScan[LXPos].rgbBlue;

        if (LDstAValue = 0) and (LDstRValue = LRValue)
          and (LDstGValue = LGValue) and (LDstBValue = LBValue) then begin
          LDstBmpScan[LXPos].rgbReserved := 0;
          LDstBmpScan[LXPos].rgbRed      := 0;
          LDstBmpScan[LXPos].rgbGreen    := 0;
          LDstBmpScan[LXPos].rgbBlue     := 0;
        end else begin
          if (LDstAValue > 0) and (LDstAValue < $FF) then begin
            LDstBmpScan[LXPos].rgbReserved := LDstAValue;
            LIsSemTrans := True;
          end else begin
            LDstBmpScan[LXPos].rgbReserved := $FF;
          end;
        end;
      end;
    end;

    // ̃rbg}bv͔̂܂܃ACRɂ邽߂̏
    if LIsSemTrans then begin
      TargetBitmap.AlphaFormat := afIgnored;
    end else begin
      TargetBitmap.AlphaFormat := afDefined;
    end;
  finally
    TargetBitmap.Canvas.Unlock;
    LSrcBitmap.Canvas.Unlock;
  end;
end;

end.
